POJ 2987 Firing (最大权闭合图,最小割)

2024-08-23 11:18

本文主要是介绍POJ 2987 Firing (最大权闭合图,最小割),希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

http://poj.org/problem?id=2987

Firing
Time Limit: 5000MS Memory Limit: 131072K
Total Submissions: 7865 Accepted: 2377

Description

You’ve finally got mad at “the world’s most stupid” employees of yours and decided to do some firings. You’re now simply too mad to give response to questions like “Don’t you think it is an even more stupid decision to have signed them?”, yet calm enough to consider the potential profit and loss from firing a good portion of them. While getting rid of an employee will save your wage and bonus expenditure on him, termination of a contract before expiration costs you funds for compensation. If you fire an employee, you also fire all his underlings and the underlings of his underlings and those underlings’ underlings’ underlings… An employee may serve in several departments and his (direct or indirect) underlings in one department may be his boss in another department. Is your firing plan ready now?

Input

The input starts with two integers n (0 < n ≤ 5000) and m (0 ≤ m ≤ 60000) on the same line. Next follows n + m lines. The first n lines of these give the net profit/loss from firing the i-th employee individuallybi (|bi| ≤ 107, 1 ≤ i ≤ n). The remaining m lines each contain two integers i and j (1 ≤ ij ≤ n) meaning the i-th employee has the j-th employee as his direct underling.

Output

Output two integers separated by a single space: the minimum number of employees to fire to achieve the maximum profit, and the maximum profit.

Sample Input

5 5
8
-9
-20
12
-10
1 2
2 5
1 4
3 4
4 5

Sample Output

2 2

Hint

As of the situation described by the sample input, firing employees 4 and 5 will produce a net profit of 2, which is maximum.

Source

POJ Monthly--2006.08.27, frkstyc


网络流。。。好强大。。。orz。。。

题意:

你的公司要裁员,裁掉某个员工可能会获得收益或损失金钱,如果裁掉某个员工,他所有的下属(直接/间接)也要被裁掉,一个员工可能有多个上级和下属,求最大收益及其最少人数。

分析:

点为员工,上级到下级之间连一条有向边,我们最后要求一个图,这个图是封闭的,即没有出边,使得点的权值和(获得/损失)最大,即求最大权闭合图。

最大权闭合图可转化为网络流解,此处仅给出方法,具体证明请参见Amber大神的《最小割模型在信息学竞赛中的应用》。

方法:

1.原图中的有向边的容量设为无穷大;

2.增加源点,连向点权为正的点,容量为点权;

3.增加汇点,点权为负的点连向汇点,容量为点权的绝对值;

4.求解该图的最小割,最大权和为正点权和减最小割;

5.在残留网络中进行深度优先搜索,去掉源点,即为最大权闭合图。


#include<cstdio>
#include<iostream>
#include<cstdlib>
#include<algorithm>
#include<ctime>
#include<cctype>
#include<cmath>
#include<string>
#include<cstring>
#include<stack>
#include<queue>
#include<list>
#include<vector>
#include<map>
#include<set>
#define sqr(x) ((x)*(x))
#define LL long long
#define itn int
#define INF 0x3f3f3f3f
#define PI 3.1415926535897932384626
#define eps 1e-10
#define maxm 70007<<1
#define maxn 5007using namespace std;const long long INFLL=0x3f3f3f3f3f3f3f3f;int fir[maxn];
int u[maxm],v[maxm],nex[maxm];
long long cap[maxm],flow[maxm];
int e_max;
int iter[maxn],q[maxn],lv[maxn];void add_edge(int _u,int _v,long long _w)
{int e;e=e_max++;u[e]=_u;v[e]=_v;cap[e]=_w;nex[e]=fir[u[e]];fir[u[e]]=e;e=e_max++;u[e]=_v;v[e]=_u;cap[e]=0;nex[e]=fir[u[e]];fir[u[e]]=e;
}void dinic_bfs(int s)
{int f,r;memset(lv,-1,sizeof lv);q[f=r=0]=s;lv[s]=0;while(f<=r){int x=q[f++];for (int e=fir[x];~e;e=nex[e]){if (cap[e]>flow[e] && lv[v[e]]<0){lv[v[e]]=lv[u[e]]+1;q[++r]=v[e];}}}
}long long dinic_dfs(int _u,int t,long long _f)
{if (_u==t)  return _f;for (int &e=iter[_u];~e;e=nex[e]){if (cap[e]>flow[e] && lv[_u]<lv[v[e]]){long long _d=dinic_dfs(v[e],t,min(_f,cap[e]-flow[e]));if (_d>0){flow[e]+=_d;flow[e^1]-=_d;return _d;}}}return 0;
}long long max_flow(int s,int t)
{memset(flow,0,sizeof flow);long long total_flow=0;for (;;){dinic_bfs(s);if (lv[t]<0)    return total_flow;memcpy(iter,fir,sizeof iter);long long _f;while ((_f=dinic_dfs(s,t,INF))>0)total_flow+=_f;}return total_flow;
}int cnt=0;
bool vis[maxn];
void dfs(int _u)
{cnt++;vis[_u]=true;for (int e=fir[_u];~e;e=nex[e])if (!vis[v[e]] && cap[e]>flow[e])dfs(v[e]);
}int main()
{#ifndef ONLINE_JUDGEfreopen("/home/fcbruce/文档/code/t","r",stdin);#endif // ONLINE_JUDGEint n,m,w;long long W=0;scanf("%d%d",&n,&m);int s=0,t=n+1;e_max=0;memset(fir,-1,sizeof fir);for (int i=1;i<=n;i++){scanf("%d",&w);if (w>0){W+=w;add_edge(s,i,w);}if (w<0){add_edge(i,t,-w);}}int _u,_v;for (int i=0;i<m;i++){scanf("%d%d",&_u,&_v);add_edge(_u,_v,INFLL);}long long max_profit=W-max_flow(s,t);memset(vis,0,sizeof vis);dfs(s);printf("%d %I64d\n",--cnt,max_profit);return 0;
}


这篇关于POJ 2987 Firing (最大权闭合图,最小割)的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/1099231

相关文章

poj 3974 and hdu 3068 最长回文串的O(n)解法(Manacher算法)

求一段字符串中的最长回文串。 因为数据量比较大,用原来的O(n^2)会爆。 小白上的O(n^2)解法代码:TLE啦~ #include<stdio.h>#include<string.h>const int Maxn = 1000000;char s[Maxn];int main(){char e[] = {"END"};while(scanf("%s", s) != EO

hdu 2602 and poj 3624(01背包)

01背包的模板题。 hdu2602代码: #include<stdio.h>#include<string.h>const int MaxN = 1001;int max(int a, int b){return a > b ? a : b;}int w[MaxN];int v[MaxN];int dp[MaxN];int main(){int T;int N, V;s

poj 1511 Invitation Cards(spfa最短路)

题意是给你点与点之间的距离,求来回到点1的最短路中的边权和。 因为边很大,不能用原来的dijkstra什么的,所以用spfa来做。并且注意要用long long int 来存储。 稍微改了一下学长的模板。 stack stl 实现代码: #include<stdio.h>#include<stack>using namespace std;const int M

poj 3259 uva 558 Wormholes(bellman最短路负权回路判断)

poj 3259: 题意:John的农场里n块地,m条路连接两块地,w个虫洞,虫洞是一条单向路,不但会把你传送到目的地,而且时间会倒退Ts。 任务是求你会不会在从某块地出发后又回来,看到了离开之前的自己。 判断树中是否存在负权回路就ok了。 bellman代码: #include<stdio.h>const int MaxN = 501;//农场数const int

poj 1258 Agri-Net(最小生成树模板代码)

感觉用这题来当模板更适合。 题意就是给你邻接矩阵求最小生成树啦。~ prim代码:效率很高。172k...0ms。 #include<stdio.h>#include<algorithm>using namespace std;const int MaxN = 101;const int INF = 0x3f3f3f3f;int g[MaxN][MaxN];int n

poj 1287 Networking(prim or kruscal最小生成树)

题意给你点与点间距离,求最小生成树。 注意点是,两点之间可能有不同的路,输入的时候选择最小的,和之前有道最短路WA的题目类似。 prim代码: #include<stdio.h>const int MaxN = 51;const int INF = 0x3f3f3f3f;int g[MaxN][MaxN];int P;int prim(){bool vis[MaxN];

poj 2349 Arctic Network uva 10369(prim or kruscal最小生成树)

题目很麻烦,因为不熟悉最小生成树的算法调试了好久。 感觉网上的题目解释都没说得很清楚,不适合新手。自己写一个。 题意:给你点的坐标,然后两点间可以有两种方式来通信:第一种是卫星通信,第二种是无线电通信。 卫星通信:任何两个有卫星频道的点间都可以直接建立连接,与点间的距离无关; 无线电通信:两个点之间的距离不能超过D,无线电收发器的功率越大,D越大,越昂贵。 计算无线电收发器D

poj 1502 MPI Maelstrom(单源最短路dijkstra)

题目真是长得头疼,好多生词,给跪。 没啥好说的,英语大水逼。 借助字典尝试翻译了一下,水逼直译求不喷 Description: BIT他们的超级计算机最近交货了。(定语秀了一堆词汇那就省略吧再见) Valentine McKee的研究顾问Jack Swigert,要她来测试一下这个系统。 Valentine告诉Swigert:“因为阿波罗是一个分布式共享内存的机器,所以它的内存访问

uva 10061 How many zero's and how many digits ?(不同进制阶乘末尾几个0)+poj 1401

题意是求在base进制下的 n!的结果有几位数,末尾有几个0。 想起刚开始的时候做的一道10进制下的n阶乘末尾有几个零,以及之前有做过的一道n阶乘的位数。 当时都是在10进制下的。 10进制下的做法是: 1. n阶位数:直接 lg(n!)就是得数的位数。 2. n阶末尾0的个数:由于2 * 5 将会在得数中以0的形式存在,所以计算2或者计算5,由于因子中出现5必然出现2,所以直接一

poj 3159 (spfa差分约束最短路) poj 1201

poj 3159: 题意: 每次给出b比a多不多于c个糖果,求n最多比1多多少个糖果。 解析: 差分约束。 这个博客讲差分约束讲的比较好: http://www.cnblogs.com/void/archive/2011/08/26/2153928.html 套个spfa。 代码: #include <iostream>#include <cstdio>#i